;; File used to declare configuration to be placed on the firmware image
;; Defaults to values found on Silicom PE3100G2DQiRM-QX4 card, as an example

.constant platform_firmware_versionNumber 0x0222 ;; Define version reported back on register. 0x0222 = same as rrcBig_02.22

.constant bootCfg_GPIO_PIN14_DRIVE 0 ;; Unknown use

.constant bootCfg_spiTransferMode 0
.constant bootCfg_spiTransferSpeed 7

.constant bootCfg_warmResetDelay 0x64
.constant bootCfg_clkMonRatio 0x00010005
.constant bootCfg_clkMonTolerance 0x000f000a
.constant bootCfg_clkMonDeadline 0x000a03e8

.constant bootCfg_pcieClkCtrl 0x492550f0 ;; PCIE_CLK_CTRL Enable, OutMuxSel, Mode
.constant bootCfg_pcieClkCtrl2 0x0f ;; PCIE_CLK_CTRL_2 XclkTerm

;; Picks between DEVICE_CFG.SystimeClockSource values. 0 = PCIE_REFCLK, 1 = IEEE1588_REFCLK
.constant bootCfg_systimeClockSource 0

.constant bootCfg_enableSwitchRdySignal 0

.constant bootCfg_skipMemRepair 0
.constant bootCfg_skipPcieInitialization 0

.constant bootCfg_pep0_enable 1
.constant bootCfg_pep1_enable 0
.constant bootCfg_pep2_enable 1
.constant bootCfg_pep3_enable 0
.constant bootCfg_pep4_enable 1
.constant bootCfg_pep5_enable 0
.constant bootCfg_pep6_enable 1
.constant bootCfg_pep7_enable 0
.constant bootCfg_pep8_enable 0

;; Picks between 0 = 8x8x, 1 = 4x4x4x4x
.constant bootCfg_pep0_mode 0
.constant bootCfg_pep2_mode 0
.constant bootCfg_pep4_mode 0
.constant bootCfg_pep6_mode 0

.constant bootCfg_pep0_numberOfLanes 8
.constant bootCfg_pep1_numberOfLanes 0
.constant bootCfg_pep2_numberOfLanes 8
.constant bootCfg_pep3_numberOfLanes 0
.constant bootCfg_pep4_numberOfLanes 8
.constant bootCfg_pep5_numberOfLanes 0
.constant bootCfg_pep6_numberOfLanes 8
.constant bootCfg_pep7_numberOfLanes 0
.constant bootCfg_pep8_numberOfLanes 0

.constant bootCfg_pep0_gen 3
.constant bootCfg_pep1_gen 3
.constant bootCfg_pep2_gen 3
.constant bootCfg_pep3_gen 3
.constant bootCfg_pep4_gen 3
.constant bootCfg_pep5_gen 3
.constant bootCfg_pep6_gen 3
.constant bootCfg_pep7_gen 3
.constant bootCfg_pep8_gen 3

.constant bootCfg_pep0_bar4Allowed 1
.constant bootCfg_pep1_bar4Allowed 0
.constant bootCfg_pep2_bar4Allowed 1
.constant bootCfg_pep3_bar4Allowed 0
.constant bootCfg_pep4_bar4Allowed 1
.constant bootCfg_pep5_bar4Allowed 0
.constant bootCfg_pep6_bar4Allowed 1
.constant bootCfg_pep7_bar4Allowed 0
.constant bootCfg_pep8_bar4Allowed 0

.constant bootCfg_pep0_ASPMEnable 0
.constant bootCfg_pep1_ASPMEnable 0
.constant bootCfg_pep2_ASPMEnable 0
.constant bootCfg_pep3_ASPMEnable 0
.constant bootCfg_pep4_ASPMEnable 0
.constant bootCfg_pep5_ASPMEnable 0
.constant bootCfg_pep6_ASPMEnable 0
.constant bootCfg_pep7_ASPMEnable 0
.constant bootCfg_pep8_ASPMEnable 0

.constant bootCfg_pep0_vendorId 0x8086 ;; Intel Corporation
.constant bootCfg_pep1_vendorId 0x8086
.constant bootCfg_pep2_vendorId 0x8086
.constant bootCfg_pep3_vendorId 0x8086
.constant bootCfg_pep4_vendorId 0x8086
.constant bootCfg_pep5_vendorId 0x8086
.constant bootCfg_pep6_vendorId 0x8086
.constant bootCfg_pep7_vendorId 0x8086
.constant bootCfg_pep8_vendorId 0x8086

.constant bootCfg_pep0_deviceId 0x15A4 ;; Ethernet Switch FM10000 Host Interface
.constant bootCfg_pep1_deviceId 0x15A4
.constant bootCfg_pep2_deviceId 0x15A4
.constant bootCfg_pep3_deviceId 0x15A4
.constant bootCfg_pep4_deviceId 0x15A4
.constant bootCfg_pep5_deviceId 0x15A4
.constant bootCfg_pep6_deviceId 0x15A4
.constant bootCfg_pep7_deviceId 0x15A4
.constant bootCfg_pep8_deviceId 0x15A4


.constant bootCfg_pep0_subVendorId 0x1374
.constant bootCfg_pep1_subVendorId 0x1374
.constant bootCfg_pep2_subVendorId 0x1374
.constant bootCfg_pep3_subVendorId 0x1374
.constant bootCfg_pep4_subVendorId 0x1374
.constant bootCfg_pep5_subVendorId 0x1374
.constant bootCfg_pep6_subVendorId 0x1374
.constant bootCfg_pep7_subVendorId 0x1374
.constant bootCfg_pep8_subVendorId 0x1374

.constant bootCfg_pep0_subDeviceId 0x01C2
.constant bootCfg_pep1_subDeviceId 0
.constant bootCfg_pep2_subDeviceId 0x01C2
.constant bootCfg_pep3_subDeviceId 0
.constant bootCfg_pep4_subDeviceId 0x01C2
.constant bootCfg_pep5_subDeviceId 0
.constant bootCfg_pep6_subDeviceId 0x01C2
.constant bootCfg_pep7_subDeviceId 0
.constant bootCfg_pep8_subDeviceId 0



.constant bootCfg_pep_vpd_base, 0x30007d82, 0x30307631, 0x20202020, 0x00202020, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x69445250, 0x51040201, 0xffff0004, 0xffffffff, 0x31334550, 0x32473030, 0x52495144, 0x58512d4d, 0x00000034, 0x00000000, 0x00000000, 0x30323130, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x32333145, 0x32313532, 0x39323030, 0x00000030, 0x56000e90, 0x00300253
.constant bootCfg_pep0_vpd, bootCfg_pep_vpd_base, 0x30025056, 0x01565200, 0x000078bf
.constant bootCfg_pep1_vpd, bootCfg_pep_vpd_base, 0x31025056, 0x01565200, 0x000078be
.constant bootCfg_pep2_vpd, bootCfg_pep_vpd_base, 0x32025056, 0x01565200, 0x000078bd
.constant bootCfg_pep3_vpd, bootCfg_pep_vpd_base, 0x33025056, 0x01565200, 0x000078bc
.constant bootCfg_pep4_vpd, bootCfg_pep_vpd_base, 0x34025056, 0x01565200, 0x000078bb
.constant bootCfg_pep5_vpd, bootCfg_pep_vpd_base, 0x35025056, 0x01565200, 0x000078ba
.constant bootCfg_pep6_vpd, bootCfg_pep_vpd_base, 0x36025056, 0x01565200, 0x000078b9
.constant bootCfg_pep7_vpd, bootCfg_pep_vpd_base, 0x37025056, 0x01565200, 0x000078b8
.constant bootCfg_pep8_vpd, bootCfg_pep_vpd_base, 0x38025056, 0x01565200, 0x000078b7

;; Custom macs are composed of two 32-bit values, reversed
.constant bootCfg_customMac0 0xff000000, 0x000000ff ;; Corresponds to 00:00:00:FF:FF:00:00:00
.constant bootCfg_customMac1 0xff000000, 0x000000ff ;; Corresponds to 00:00:00:FF:FF:00:00:00
.constant bootCfg_customMac2 0xff000000, 0x000000ff ;; Corresponds to 00:00:00:FF:FF:00:00:00
.constant bootCfg_customMac3 0xff000000, 0x000000ff ;; Corresponds to 00:00:00:FF:FF:00:00:00