;; Copyright (c) 2021, rrc-open-firmware FM10K-Documentation Contributors
;
;; Redistribution and use in source and binary forms, with or without
;; modification, are permitted provided that the following conditions are met:
;
;;     * Redistributions of source code must retain the above copyright notice,
;;       this list of conditions and the following disclaimer.
;;     * Redistributions in binary form must reproduce the above copyright
;;       notice, this list of conditions and the following disclaimer in the
;;       documentation and/or other materials provided with the distribution.
;;     * Neither the name of the copyright holder nor the names of its contributors
;;       may be used to endorse or promote products derived from this software
;;       without specific prior written permission.
;
;; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
;; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;; IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
;; DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
;; FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;; DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
;; SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
;; CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;; OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
;; OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


; FASTCALL void(bool pep0, bool pep2, bool pep4, bool pep6)
init_setPcieSplitMode:
    SET DEVICE_CFG, 0, DEVICE_CFG.PCIeMode        ; Reset PCIe modes PCIeMode[0..3]
    BEQ P0, 0, 0x1, @.continue0   ; PEP0
        SET DEVICE_CFG, DEVICE_CFG.PCIeMode_0, DEVICE_CFG.PCIeMode_0    ; Set PCIeMode[0] = 1 (4x4x4x4)
    .continue0:

    BEQ P1, 0, 0x1, @.continue2   ; PEP2
        SET DEVICE_CFG, DEVICE_CFG.PCIeMode_2, DEVICE_CFG.PCIeMode_2 ; Set PCIeMode[1] = 1 (4x4x4x4)
    .continue2:

    BEQ~2 P2, 0, 0x1, @.continue4 ; access POPP 1 PEP4
        SET DEVICE_CFG, DEVICE_CFG.PCIeMode_4, DEVICE_CFG.PCIeMode_4 ; Set PCIeMode[2] = 1 (4x4x4x4)
    .continue4:

    BEQ~2 P3, 0, 0x1, @.continue6 ; access POPP 2 PEP6
        SET DEVICE_CFG, DEVICE_CFG.PCIeMode_6, DEVICE_CFG.PCIeMode_6 ; Set PCIeMode[3] = 1 (4x4x4x4)
    .continue6:
    RET

; FASTCALL void(bool pep0, bool pep1, bool pep2, bool pep3, bool pep4, bool pep5, bool pep6, bool pep7, bool pep8)
init_setPciePEPEnabled:
    BEQ P0, 1, 0x1, @.continue0    ; PEP0
         SET DEVICE_CFG, 0, DEVICE_CFG.PCIeEnable_0   ; Set PCIEnable[0] = 0, default 1
    .continue0:

    BEQ P1, 1, 0x1, @.continue1    ; PEP1
         SET DEVICE_CFG, 0, DEVICE_CFG.PCIeEnable_1   ; Set PCIEnable[1] = 0, default 1
    .continue1:

    BEQ~2 P2, 1, 0x1, @.continue2  ; PEP2
         SET DEVICE_CFG, 0, DEVICE_CFG.PCIeEnable_2   ; Set PCIEnable[2] = 0, default 1
    .continue2:

    BEQ~2 P3, 1, 0x1, @.continue3  ; PEP3
         SET DEVICE_CFG, 0, DEVICE_CFG.PCIeEnable_3  ; Set PCIEnable[3] = 0, default 1
    .continue3:

    BEQ~2 P4, 1, 0x1, @.continue4  ; PEP4
         SET DEVICE_CFG, 0, DEVICE_CFG.PCIeEnable_4  ; Set PCIEnable[4] = 0, default 1
    .continue4:

    BEQ~2 P5, 1, 0x1, @.continue5  ; PEP5
         SET DEVICE_CFG, 0, DEVICE_CFG.PCIeEnable_5  ; Set PCIEnable[5] = 0, default 1
    .continue5:

    BEQ~2 P6, 1, 0x1, @.continue6  ; PEP6
         SET DEVICE_CFG, 0, DEVICE_CFG.PCIeEnable_6  ; Set PCIEnable[6] = 0, default 1
    .continue6:

    BEQ~2 P7, 1, 0x1, @.continue7  ; PEP7
         SET DEVICE_CFG, 0, DEVICE_CFG.PCIeEnable_7  ; Set PCIEnable[7] = 0, default 1
    .continue7:

    BEQ~2 P8, 1, 0x1, @.continue8  ; PEP8
         SET DEVICE_CFG, 0, DEVICE_CFG.PCIeEnable_8  ; Set PCIEnable[8] = 0, default 1
    .continue8:

    RET

; CALL bool(), Return in RRET
; TODO: make this a proper loop with n retries
lock_PCIE_SBUS_take:
    PNE api_PCIE_SBUS_LOCK_STATE, 0, 0x3, 20000, 50, @.failToTakeLock ; Check if something else is holding the lock, and wait until freed
        SET api_PCIE_SBUS_LOCK_STATE, 1, 0x3 ; Take lock for ourselves
        BNE api_PCIE_SBUS_LOCK_STATE, 1, 0x3, @.tryTakeLockAgain; Check if we actually took the lock or driver/switch manager did, or retry
            RET 1 ; Success
        .tryTakeLockAgain:
        PNE api_PCIE_SBUS_LOCK_STATE, 0, 0x3, 20000, 50, @.failToTakeLock ; Check if something else is holding the lock, and wait until freed
        SET api_PCIE_SBUS_LOCK_STATE, 1, 0x3 ; Take lock for ourselves
        BNE api_PCIE_SBUS_LOCK_STATE, 1, 0x3, @.failToTakeLock; Check if we actually took the lock or driver/switch manager did
            RET 1 ; Success
    .failToTakeLock:
    SET api_SW_LOCK_ERR_STATUS, 1, 0x1
    BEQ api_SW_LOCK_ERR_STATUS, 0xfe, 0xfe, @.resetErrorStatus
        ADD api_SW_LOCK_ERR_STATUS, api_SW_LOCK_ERR_STATUS, 2
        RET 0 ; Failure
    .resetErrorStatus:
    SET api_SW_LOCK_ERR_STATUS, 0, 0xfe
    ADD api_SW_LOCK_ERR_STATUS, api_SW_LOCK_ERR_STATUS, 2
    RET 0 ; Failure

lock_PCIE_SBUS_release:
    BNE api_PCIE_SBUS_LOCK_STATE, platform_PCIE_SBUS_LOCK_NVM, 0x3, @.return  ; If we hold the lock
        SET api_PCIE_SBUS_LOCK_STATE, platform_PCIE_SBUS_LOCK_FREE, 0x3        ; Release lock
    .return:
    RET

; FASTCALL bool, uint result(uint & 0xff Register, uint & 0xff DeviceAddress, bool doRead, uint commandData). bool is in RRET, result in RRET_X
;;
;; This is defined on datasheet, page 372, 9.3 SerDes Management and Temperature as pseudocode:
;;
;;  sbus_xxx_command (device, register, command, data)
;;  {
;;   // Write data
;;   SBUS_XXX_REQUEST = data;
;;   // Start command
;;   SBUS_XXX_COMMAND    = (1 << 24) /*Execute*/
;;                       + (((command==Write) ? 0x21 : (command==Read) ? 0x22 : 0x0) << 16)
;;                       + (device << 8)
;;                       + (register);
;;
;;   // Wait for command to complete
;;   while (SBUS_XXX_COMMAND.Busy) yield();
;;
;;   // Check result status (optional; failure indicates invalid device number)
;;   result = SBUS_XXX_COMMAND.ResultCode;
;;   if ( command == Write && result != 0x1 ) error;
;;   if ( command == Read && result != 0x4 ) error;
;;
;;   // Clear register for next command
;;   SBUS_XXX_COMMAND = 0;
;;
;;   // Read data
;;   data = SBUS_XXX_RESPONSE;
;;   return data;
;;  }
;;
execute_SBus_PCIE_Command:
    GET SBUS_PCIE_REQUEST, GET_P3                   ; Set commandData into the request
    SHL R0, P1, SBUS_PCIE_COMMAND.Address.offset    ; P1 << 8
    AND R0, R0, SBUS_PCIE_COMMAND.Address           ; Mask to just Address
    SET R0, P0, SBUS_PCIE_COMMAND.Register          ; Combine (Address << 8) | Register

    BEQ~2 P2, 1, 0x1, @.doRead                      ; Check if we are doing a write or read op
        ; Do write
        SET R0, 0x21 <16, SBUS_PCIE_COMMAND.Op      ; Set WRITE Op 0x21
        MOV R1, 1 <26                               ; Expected success value for write ResultCode
        JUMP @.executeCommand
    .doRead:
        ; Do read
        SET R0, 0x22 <16, SBUS_PCIE_COMMAND.Op      ; Set READ Op 0x22
        MOV R1, 1 <28                               ; Expected success value for read ResultCode
    .executeCommand:
    MOV SBUS_PCIE_COMMAND, R0                       ; Write command and operators
    SET SBUS_PCIE_COMMAND, SBUS_PCIE_COMMAND.Execute, SBUS_PCIE_COMMAND.Execute ; Set Execute = 1 to start the command. Should automatically set Busy = 1 as well
    PNE SBUS_PCIE_COMMAND, 0, SBUS_PCIE_COMMAND.Busy, 65535, 1, @.failCommand ; Poll until Busy = 0
        AND R0, SBUS_PCIE_COMMAND, SBUS_PCIE_COMMAND.ResultCode.mask ; Get ResultCode
        SUB R0, R0, R1                              ; Compare ResultCode to expected
        BNE R0, 0, 0xffffffff, @.failCommand        ; Fail if ResultCode != Expected Success ResultCode
        .successCommand:
        MOV RRET_X, SBUS_PCIE_RESPONSE
        MOV SBUS_PCIE_COMMAND, 0                    ; Reset command
        RET 1                                       ; Success
    .failCommand:
    MOV RRET_X, SBUS_PCIE_RESPONSE
    MOV SBUS_PCIE_COMMAND, 0                        ; Reset command
    RET 0                                           ; Fail


init_PCIE_MASTER_SPICO:
    MOV api_PCIE_MASTER_STATUS, 0
    MOV api_BSM_STATUS, api_BSM_STATUS.PCIe_Master_SPICO_Pre_FirmwareDownload

    ; Set SBus frequency to refclk/2 for ethernet
    FASTCALL @execute_SBus_PCIE_Command, 0x0a, platform_PCIE_SBUS_CONTROLLER_DEVICE_ADDRESS, 0, 0x01
    BNE RRET, 1, 0x1, @.failCommand ; Command failed

    ; Place Master SPICO into Reset and Enable off
    FASTCALL @execute_SBus_PCIE_Command, 0x01, platform_PCIE_MASTER_SPICO_DEVICE_ADDRESS, 0, 0xc0
    BNE RRET, 1, 0x1, @.failCommand ; Command failed

    ; Remove Reset, Enable off, IMEM_CNTL_EN on
    FASTCALL @execute_SBus_PCIE_Command, 0x01, platform_PCIE_MASTER_SPICO_DEVICE_ADDRESS, 0, 0x0240
    BNE RRET, 1, 0x1, @.failCommand ; Command failed

    ; Set starting IMEM address for burst download
    FASTCALL @execute_SBus_PCIE_Command, 0x03, platform_PCIE_MASTER_SPICO_DEVICE_ADDRESS, 0, 0x80000000
    BNE RRET, 1, 0x1, @.failCommand ; Command failed

    MOV api_BSM_STATUS, api_BSM_STATUS.PCIe_Master_SPICO_FirmwareDownload
    ; Write firmware image to Master SPICO
    CALL @download_master_spico_fw
    MOV api_BSM_STATUS, api_BSM_STATUS.PCIe_Master_SPICO_Post_FirmwareDownload

    ; Start the Master SPICO controller
    FASTCALL @execute_SBus_PCIE_Command, 0x01, platform_PCIE_MASTER_SPICO_DEVICE_ADDRESS, 0, 0x40 ; Set IMEM_CNTL_EN off
    BNE RRET, 1, 0x1, @.failCommand ; Command failed

    FASTCALL @execute_SBus_PCIE_Command, 0x16, platform_PCIE_MASTER_SPICO_DEVICE_ADDRESS, 0, 0x000c0000 ; Turn ECC on
    BNE RRET, 1, 0x1, @.failCommand ; Command failed

    FASTCALL @execute_SBus_PCIE_Command, 0x01, platform_PCIE_MASTER_SPICO_DEVICE_ADDRESS, 0, 0x0140 ; Set SPICO_ENABLE on
    BNE RRET, 1, 0x1, @.failCommand ; Command failed

    MOV api_MASTER_FW_VERSION, platform_MASTER_FW_VERSION

    MOV api_BSM_STATUS, api_BSM_STATUS.PCIe_Master_SPICO_FirmwareDownload_Success
    MOV api_PCIE_MASTER_FW_DL_STATUS, api_BSM_STATUS
    RET 1 ; Success

    .failCommand:
    SET api_BSM_STATUS, 0x0000fff0, 0x0000fff0 ; or (?) MOV api_BSM_STATUS api_BSM_STATUS.PCIe_Master_SPICO_FirmwareDownload_Error
    MOV api_PCIE_MASTER_FW_DL_STATUS, api_BSM_STATUS
    MOV api_PCIE_MASTER_STATUS, 1
    RET 0 ; Failure

init_ALL_PCIE_SERDES_SPICO:
    MOV api_PCIE_SERDES_STATUS, 0

    MOV R0, 0 ; Why, this must be a constant!
    BEQ R0, 1, 0x1, @.skipUnlock
        MOV api_BSM_STATUS, api_BSM_STATUS.PCIe_SerDes_Pre_FirmwareDownload

        ; Place SerDes in Reset & disable SPICO
        FASTCALL @execute_SBus_PCIE_Command, 0x07, platform_PCIE_ALL_SERDES_SPICO_DEVICE_ADDRESS, 0, 0x11
        BNE RRET, 1, 0x1, @.failCommand ; Command failed

        ; Remove SerDes Reset
        FASTCALL @execute_SBus_PCIE_Command, 0x07, platform_PCIE_ALL_SERDES_SPICO_DEVICE_ADDRESS, 0, 0x10
        BNE RRET, 1, 0x1, @.failCommand ; Command failed

        ; Assert IMEM override
        FASTCALL @execute_SBus_PCIE_Command, 0x00, platform_PCIE_ALL_SERDES_SPICO_DEVICE_ADDRESS, 0, 0x40000000
        BNE RRET, 1, 0x1, @.failCommand ; Command failed

    .skipUnlock: ; (??)


    MOV api_BSM_STATUS, api_BSM_STATUS.PCIe_SerDes_FirmwareDownload
    CALL @download_serdes_spico_fw
    MOV R1, 0 ; Why, this must be a constant!
    BEQ R1, 1, 0x1, @.skipFullLock
        MOV api_BSM_STATUS, api_BSM_STATUS.PCIe_SerDes_Post_FirmwareDownload
        MOV R2, 0 ; Why, this must be a constant!
        BEQ R2, 0, 0x1, @.skipLock

            FASTCALL @execute_SBus_PCIE_Command, 0x0a, platform_PCIE_ALL_SERDES_SPICO_DEVICE_ADDRESS, 0, 0xc000
            BNE RRET, 1, 0x1, @.failCommand ; Command failed

            FASTCALL @execute_SBus_PCIE_Command, 0x0a, platform_PCIE_ALL_SERDES_SPICO_DEVICE_ADDRESS, 0, 0xc000
            BNE RRET, 1, 0x1, @.failCommand ; Command failed

            FASTCALL @execute_SBus_PCIE_Command, 0x0a, platform_PCIE_ALL_SERDES_SPICO_DEVICE_ADDRESS, 0, 0xc000
            BNE RRET, 1, 0x1, @.failCommand ; Command failed

        .skipLock: ; (??)

        ; Start SerDes controller
        FASTCALL @execute_SBus_PCIE_Command, 0x00, platform_PCIE_ALL_SERDES_SPICO_DEVICE_ADDRESS, 0, 0x00 ; IMEM override off
        BNE RRET, 1, 0x1, @.failCommand ; Command failed

        FASTCALL @execute_SBus_PCIE_Command, 0x0b, platform_PCIE_ALL_SERDES_SPICO_DEVICE_ADDRESS, 0, 0x0c0000 ; Turn ECC on
        BNE RRET, 1, 0x1, @.failCommand ; Command failed

        FASTCALL @execute_SBus_PCIE_Command, 0x07, platform_PCIE_ALL_SERDES_SPICO_DEVICE_ADDRESS, 0, 0x02 ; Turn SPICO Enable on
        BNE RRET, 1, 0x1, @.failCommand ; Command failed

        FASTCALL @execute_SBus_PCIE_Command, 0x08, platform_PCIE_ALL_SERDES_SPICO_DEVICE_ADDRESS, 0, 0x00 ; Enable core and hardware interrupts
        BNE RRET, 1, 0x1, @.failCommand ; Command failed

    .skipFullLock: ; (??)
    MOV api_SERDES_FW_VERSION, platform_SERDES_FW_VERSION

    ; TODO: move this to its own call
    MOV R3, 1 ; Why, this must be a constant!. Also registered loc_089110_load_config_unknown_1 on original code
    BEQ R3, 0, 0x1, @.successCommand ; Skip CRC and version checks
        MOV api_BSM_STATUS, api_BSM_STATUS.PCIe_SerDes_Firmware_Verification_Status_Version_CRC

        ; Execute Master SPICO CRC check interrupt
        FASTCALL @execute_SBus_PCIE_Command, 0x02, platform_PCIE_MASTER_SPICO_DEVICE_ADDRESS, 0, 0x02 ; Do MASTER FW CRC check
        BNE RRET, 1, 0x1, @.failCommand ; Command failed

        FASTCALL @execute_SBus_PCIE_Command, 0x07, platform_PCIE_MASTER_SPICO_DEVICE_ADDRESS, 0, 0x01 ; Do MASTER FW CRC check read result
        BNE RRET, 1, 0x1, @.failCommand ; Command failed

        ; Execute SerDes CRC check interrupts (broadcast)
        FASTCALL @execute_SBus_PCIE_Command, 0x03, platform_PCIE_ALL_SERDES_SPICO_DEVICE_ADDRESS, 0, 0x3c0000 ; Do All SerDes FW CRC check
        BNE RRET, 1, 0x1, @.failCommand ; Command failed

        WAIT 1000

        .doMasterCRCCheck:
        FASTCALL @execute_SBus_PCIE_Command, 0x09, platform_PCIE_MASTER_SPICO_DEVICE_ADDRESS, 1, 0x00 ; Check MASTER FW CRC check
        BNE RRET, 1, 0x1, @.failCommand ; Command failed
        BEQ RRET_X, 0x00008000, 0x00008000, @.doMasterCRCCheck ; Poll Master SPICO for completion (only check bit[15])

        ; Check Master SPICO result
        BNE RRET_X, 0x00010000, 0xffff0000, @.doAllSerdesCRCCheck ; If check failed, skip setting the proper value, (0x0001 is pass, 0xFFFF is fail)
            ; Command Executed
            SET api_BSM_STATUS, 0x00100000, 0x00100000 ; Set Master CRC = OK
            MOV api_PCIE_FW_CHECK_STATUS, api_BSM_STATUS
            WRITE api_SERDES_STATUS_1, 0x00000000, 0x00000000 ; 64-bit write

        .doAllSerdesCRCCheck:
        MOV BSM_COUNTER_1, platform_SERDES_SPICO_COUNT ; Number of SerDes SPICO
        .loopAllSerdesCRCCheck:
        BEQ BSM_COUNTER_1, 0, 0xffffffff, @.finishAllSerdesCRCCheck
            BEQ BSM_COUNTER_1, 0, 0x00000001, @.doSingleSerdesCRCCheck
                SUB BSM_COUNTER_1, BSM_COUNTER_1, 1
                JUMP @.loopAllSerdesCRCCheck
            .doSingleSerdesCRCCheck:
            FASTCALL @execute_SBus_PCIE_Command, 0x04, BSM_COUNTER_1, 1, 0x00 ; Do SerDes SPICO read
            BNE RRET, 1, 0x1, @.failCommand ; Command failed
            BEQ RRET_X, 0x00010000, 0x00010000, @.doSingleSerdesCRCCheck ; Poll SerDes for completion (only check bit[16])

            ; Check SerDes result
            BNE RRET_X, 0x00000000, 0x0000ffff, @.finishAllSerdesCRCCheck ; If check failed, skip setting the proper value, (0x00 is pass, 0xFF is fail)
                ; Prepare and set register for success
                MOV R4, 0x00000001
                BEQ BSM_COUNTER_1, platform_SERDES_SPICO_COUNT, 0xffffffff, @.setAllSerdesCRCCheckValue ; Number of SerDes SPICO
                SHR R5, BSM_COUNTER_1, 1
                SUB R5, R5, 1
                SHL R4, R4, R5
                ; R4 = 1 << (R5 = (BSM_COUNTER[1] >> 1) - 1)
                OR api_SERDES_STATUS_1, api_SERDES_STATUS_1, R4
                JUMP @.finishAllSerdesCRCCheck
            .setAllSerdesCRCCheckValue:
                MOV api_SERDES_STATUS_2, R4

        .finishAllSerdesCRCCheck:
        LOOP~1, @.loopAllSerdesCRCCheck

        BNE api_SERDES_STATUS_2, 0x01, 0xffffffff, @.doMasterVersionCheck; Checks failed
        BNE api_SERDES_STATUS_1, 0xffffffff, 0xffffffff, @.doMasterVersionCheck; Checks failed
        SET api_BSM_STATUS, 0x00200000, 0x00200000 ; Set All Serdes CRC = OK
        MOV api_PCIE_FW_CHECK_STATUS, api_BSM_STATUS

        .doMasterVersionCheck:
        ; Execute Master SPICO Revision check interrupt
        FASTCALL @execute_SBus_PCIE_Command, 0x02, platform_PCIE_MASTER_SPICO_DEVICE_ADDRESS, 0, 0x00 ; Do MASTER FW Version check
        BNE RRET, 1, 0x1, @.failCommand ; Command failed

        FASTCALL @execute_SBus_PCIE_Command, 0x07, platform_PCIE_MASTER_SPICO_DEVICE_ADDRESS, 0, 0x01 ; Do MASTER FW Version check read result
        BNE RRET, 1, 0x1, @.failCommand ; Command failed

        .doMasterVersionCheckRead:
        FASTCALL @execute_SBus_PCIE_Command, 0x08, platform_PCIE_MASTER_SPICO_DEVICE_ADDRESS, 1, 0x00 ; Check MASTER FW Version
        BNE RRET, 1, 0x1, @.failCommand ; Command failed
        BEQ RRET_X, 0x00008000, 0x00008000, @.doMasterVersionCheckRead ; Poll Master SPICO for completion (only check bit[15])

        ; Compare api_MASTER_FW_VERSION and Returned version
        AND R6, api_MASTER_FW_VERSION, 0xffff0000
        AND R7, RRET_X, 0xffff0000
        SUB R6, R6, R7

        BNE R6, 0x00000000, 0xffffffff, @.doAllSerdesVersionCheck ; If check failed, skip setting the proper value
            ; Command Executed
            SET api_BSM_STATUS, 0x01000000, 0x01000000 ; Set Master version = OK
            MOV api_PCIE_FW_CHECK_STATUS, api_BSM_STATUS

        .doAllSerdesVersionCheck:
        ; Execute SerDes Revision check interrupts (broadcast)
        FASTCALL @execute_SBus_PCIE_Command, 0x03, platform_PCIE_ALL_SERDES_SPICO_DEVICE_ADDRESS, 0, 0x00 ; Do All SerDes FW Version check
        BNE RRET, 1, 0x1, @.failCommand ; Command failed
        WRITE api_SERDES_STATUS_3, 0x00000000, 0x00000000 ; 64-bit write
        
        MOV BSM_COUNTER_1, platform_SERDES_SPICO_COUNT ; Number of SerDes SPICO
        AND R6, api_SERDES_FW_VERSION, 0xffff0000
        SHR R6, R6, 0x10 ; R6 >> 0x10

        .loopAllSerdesVersionCheck:
        BEQ BSM_COUNTER_1, 0, 0xffffffff, @.finishAllSerdesVersionCheck
            BEQ BSM_COUNTER_1, 0, 0x00000001, @.doSingleSerdesVersionCheck
                SUB BSM_COUNTER_1, BSM_COUNTER_1, 1
                JUMP @.loopAllSerdesVersionCheck

            .doSingleSerdesVersionCheck:
            FASTCALL @execute_SBus_PCIE_Command, 0x04, BSM_COUNTER_1, 1, 0x00 ; Do SerDes SPICO read
            BNE RRET, 1, 0x1, @.failCommand ; Command failed
            BEQ RRET_X, 0x00010000, 0x00010000, @.doSingleSerdesVersionCheck ; Poll SerDes for completion (only check bit[16])

            AND R7, RRET_X, 0x0000ffff
            SUB R7, R6, R7 ; Compare against api_SERDES_FW_VERSION

            BNE R7, 0x00000000, 0xffffffff, @.finishAllSerdesVersionCheck ; If check failed, skip setting the proper value
                ; Prepare and set register for success
                MOV R4, 0x00000001
                BEQ BSM_COUNTER_1, platform_SERDES_SPICO_COUNT, 0xffffffff, @.setAllSerdesVersionCheckValue ; Number of SerDes SPICO
                SHR R5, BSM_COUNTER_1, 1
                SUB R5, R5, 1
                SHL R4, R4, R5
                ; R4 = 1 << (R5 = (BSM_COUNTER[1] >> 1) - 1)
                OR api_SERDES_STATUS_3, api_SERDES_STATUS_3, R4
                JUMP @.finishAllSerdesVersionCheck
            .setAllSerdesVersionCheckValue:
                MOV api_SERDES_STATUS_4, R4

        .finishAllSerdesVersionCheck:
        LOOP~1, @.loopAllSerdesVersionCheck

        BNE api_SERDES_STATUS_4, 0x01, 0xffffffff, @.successCommand ; Checks failed
        BNE api_SERDES_STATUS_3, 0xffffffff, 0xffffffff, @.successCommand ; Checks failed
        SET api_BSM_STATUS, 0x00200000, 0x00200000 ; Set All Serdes version = OK
        MOV api_PCIE_FW_CHECK_STATUS, api_BSM_STATUS
    .successCommand:
    MOV api_BSM_STATUS, api_BSM_STATUS.PCIe_SerDes_FirmwareDownload_Success
    MOV api_PCIE_SERDES_FW_DL_STATUS, api_BSM_STATUS
    RET 1 ; Success

    .failCommand:
    SET api_BSM_STATUS, 0x0000fff0, 0x0000fff0 ; or (?) MOV api_BSM_STATUS, api_BSM_STATUS.PCIe_SerDes_FirmwareDownload_Error
    MOV api_PCIE_SERDES_FW_DL_STATUS, api_BSM_STATUS
    MOV api_PCIE_SERDES_STATUS, 1
    RET 0 ; Failure


init_PCIE_EACH_SERDES_SPICO:
    MOV api_BSM_STATUS, api_BSM_STATUS.PCIe_SerDes_Initialization_Starting

    MOV R0, 2 ; Current SERDES device index
    MOV R1, 0x00e00ff0 ; Current data to write
    MOV R2, 0x000000d0 ; Current data to write to odd (PCS)

    .do:
        BEQ, R0, 1, 0x1 @.commandOddPcs; Is it odd (PCS)?
            FASTCALL @execute_SBus_PCIE_Command, 0xfd, R0, 0, R1 ; Execute command
            JUMP @.nextItem
        .commandOddPcs:
            ; Do odd number init (PCS)
            FASTCALL @execute_SBus_PCIE_Command, 0x24, R0, 0, R2 ; Execute command
        .nextItem:
        BNE RRET, 1, 0x1, @.failCommand ; Command failed
        ADD R0, R0, 1 ; Increase index for next spico

        .check0: BNE, R0, 0x0a, 0xFFFFFFFF, @.check1
            BEQ DEVICE_CFG, 0, DEVICE_CFG.PCIeMode_0, @.check1 ; PEP0 is 8x8x
                MOV R1, 0x00e10ff0
                MOV R2, 0x000000d1
        .check1: BNE, R0, 0x12, 0xFFFFFFFF, @.check2
            MOV R1, 0x00e20ff0
            MOV R2, 0x000000d2

        .check2: BNE, R0, 0x1a, 0xFFFFFFFF, @.check3
            BEQ DEVICE_CFG, 0, DEVICE_CFG.PCIeMode_2, @.check3 ; PEP2 is 8x8x
                MOV R1, 0x00e30ff0
                MOV R2, 0x000000d3
        .check3: BNE, R0, 0x22, 0xFFFFFFFF, @.check4
            MOV R1, 0x00e40ff0
            MOV R2, 0x000000d4

        .check4: BNE, R0, 0x3a, 0xFFFFFFFF, @.check5
            BEQ DEVICE_CFG, 0, DEVICE_CFG.PCIeMode_4, @.check5 ; PEP4 is 8x8x
                MOV R1, 0x00e50ff0
                MOV R2, 0x000000d5
        .check5: BNE, R0, 0x32, 0xFFFFFFFF, @.check6
            MOV R1, 0x00e60ff0
            MOV R2, 0x000000d6

        .check6: BNE, R0, 0x4a, 0xFFFFFFFF, @.continue
            BEQ DEVICE_CFG, 0, DEVICE_CFG.PCIeMode_6, @.continue ; PEP6 is 8x8x
                MOV R1, 0x00e70ff0
                MOV R2, 0x000000d7
        .continue:
    BNE R0, platform_SERDES_SPICO_COUNT, 0xFFFFFFFF, @.do

    MOV api_SERDES_OOR_STATUS_PASS_1, 0
    MOV api_SW_LOCK_ERR_STATUS, 0
    MOV api_BSM_STATUS, api_BSM_STATUS.PCIe_SerDes_Complete_Success
    MOV api_PCIE_SERDES_INIT_STATUS, api_BSM_STATUS
    RET 1 ; Success
    .failCommand:
    SET api_BSM_STATUS, 0x0000fff0, 0x0000fff0
    MOV api_PCIE_SERDES_INIT_STATUS, api_BSM_STATUS
    MOV api_PCIE_SERDES_STATUS, 1
    RET 0 ; Failure

init_PCIE_SERDES_PCS:
    MOV api_BSM_STATUS, api_BSM_STATUS.Enable_PCIe_PCS_Interrupts_Starting
    FASTCALL @init_PCIE_SERDES_PCS_config, 1, 0x00000000, bootCfg_pep0_enable, bootCfg_pep1_enable, bootCfg_pep2_enable, bootCfg_pep3_enable, bootCfg_pep4_enable, bootCfg_pep5_enable, bootCfg_pep6_enable, bootCfg_pep7_enable, bootCfg_pep8_enable
    MOV api_PCIE_PCS_EN_STATUS, api_BSM_STATUS
    RET

; FASTCALL ??(bool P0, ____unused P1, PEP0, PEP1, PEP2, PEP3, PEP4, PEP5, PEP6, PEP7, PEP8)
init_PCIE_SERDES_PCS_config:
    MOV R0, 0, 0 ; Write R0 and R1
    BEQ P0, 1, 0x1, @.skipSetting1toR0
         MOV R0, 1
    .skipSetting1toR0:

    MOV R2, BSM_ADDR_OFFSET_1 ; Save offset 2

    MOV BSM_ADDR_OFFSET_1, 0x000000 ; PCIe base address for PEP


    BEQ~2, P2, 0, 0x1, @.skip_PEP0_init ; Get PEP0 parameter
        CALL @._init_PCIE_SERDES_PCS_config_doRegisterWrites_a
        BEQ DEVICE_CFG, DEVICE_CFG.PCIeMode_0, DEVICE_CFG.PCIeMode_0, @.skip_PEP0_init
        CALL @._init_PCIE_SERDES_PCS_config_doRegisterWrites_b
    .skip_PEP0_init:
    SET api_BSM_STATUS, 0x00100000, 0x00100000
    ADD BSM_ADDR_OFFSET_1, BSM_ADDR_OFFSET_1, 0x100000

    BEQ~2, P3, 0, 0x1, @.skip_PEP1_init ; Get PEP1 parameter
        CALL @._init_PCIE_SERDES_PCS_config_doRegisterWrites_b
    .skip_PEP1_init:
    SET api_BSM_STATUS, 0x00200000, 0x00200000
    ADD BSM_ADDR_OFFSET_1, BSM_ADDR_OFFSET_1, 0x100000


    BEQ~2, P4, 0, 0x1, @.skip_PEP2_init ; Get PEP2 parameter
        CALL @._init_PCIE_SERDES_PCS_config_doRegisterWrites_a
        BEQ DEVICE_CFG, DEVICE_CFG.PCIeMode_2, DEVICE_CFG.PCIeMode_2, @.skip_PEP2_init
        CALL @._init_PCIE_SERDES_PCS_config_doRegisterWrites_b
    .skip_PEP2_init:
    SET api_BSM_STATUS, 0x00400000, 0x00400000
    ADD BSM_ADDR_OFFSET_1, BSM_ADDR_OFFSET_1, 0x100000

    BEQ~2, P5, 0, 0x1, @.skip_PEP3_init ; Get PEP3 parameter
        CALL @._init_PCIE_SERDES_PCS_config_doRegisterWrites_b
    .skip_PEP3_init:
    SET api_BSM_STATUS, 0x00800000, 0x00800000
    ADD BSM_ADDR_OFFSET_1, BSM_ADDR_OFFSET_1, 0x100000


    BEQ~2, P6, 0, 0x1, @.skip_PEP4_init ; Get PEP4 parameter
        CALL @._init_PCIE_SERDES_PCS_config_doRegisterWrites_a
        BEQ DEVICE_CFG, DEVICE_CFG.PCIeMode_4, DEVICE_CFG.PCIeMode_4, @.skip_PEP4_init
        CALL @._init_PCIE_SERDES_PCS_config_doRegisterWrites_b
    .skip_PEP4_init:
    SET api_BSM_STATUS, 0x01000000, 0x01000000
    ADD BSM_ADDR_OFFSET_1, BSM_ADDR_OFFSET_1, 0x100000

    BEQ~2, P7, 0, 0x1, @.skip_PEP5_init ; Get PEP5 parameter
        CALL @._init_PCIE_SERDES_PCS_config_doRegisterWrites_b
    .skip_PEP5_init:
    SET api_BSM_STATUS, 0x02000000, 0x02000000
    ADD BSM_ADDR_OFFSET_1, BSM_ADDR_OFFSET_1, 0x100000


    BEQ~2, P8, 0, 0x1, @.skip_PEP6_init ; Get PEP6 parameter
        CALL @._init_PCIE_SERDES_PCS_config_doRegisterWrites_a
        BEQ DEVICE_CFG, DEVICE_CFG.PCIeMode_6, DEVICE_CFG.PCIeMode_6, @.skip_PEP6_init
        CALL @._init_PCIE_SERDES_PCS_config_doRegisterWrites_b
    .skip_PEP6_init:
    SET api_BSM_STATUS, 0x04000000, 0x04000000
    ADD BSM_ADDR_OFFSET_1, BSM_ADDR_OFFSET_1, 0x100000

    BEQ~2, P9, 0, 0x1, @.skip_PEP7_init ; Get PEP7 parameter
        CALL @._init_PCIE_SERDES_PCS_config_doRegisterWrites_b
    .skip_PEP7_init:
    SET api_BSM_STATUS, 0x08000000, 0x08000000
    ADD BSM_ADDR_OFFSET_1, BSM_ADDR_OFFSET_1, 0x100000

    BEQ~2, P10, 0, 0x1, @.skip_PEP8_init ; Get PEP8 parameter
        COPY~10, PCIE_SERDES_CTRL_0, R0, 2 ; Copy two words
    .skip_PEP8_init:
    SET api_BSM_STATUS, 0x10000000, 0x10000000


    MOV BSM_ADDR_OFFSET_1, R2 ; Restore offset 1
    RET
    ._init_PCIE_SERDES_PCS_config_doRegisterWrites_a:
        COPY~10, PCIE_SERDES_CTRL_0, R0, 2 ; Copy two words
        COPY~10, PCIE_SERDES_CTRL_1, R0, 2 ; Copy two words
        COPY~10, PCIE_SERDES_CTRL_2, R0, 2 ; Copy two words
        COPY~10, PCIE_SERDES_CTRL_3, R0, 2 ; Copy two words
        RET
    ._init_PCIE_SERDES_PCS_config_doRegisterWrites_b:
        COPY~10, PCIE_SERDES_CTRL_4, R0, 2 ; Copy two words
        COPY~10, PCIE_SERDES_CTRL_5, R0, 2 ; Copy two words
        COPY~10, PCIE_SERDES_CTRL_6, R0, 2 ; Copy two words
        COPY~10, PCIE_SERDES_CTRL_7, R0, 2 ; Copy two words
        RET